import java.lang.Math;
import java.util.Random; 

public class BinaryHeap{
    private int[] heap;
    private int maxCap;
    private int nbOfElem;

    public BinaryHeap(int size){
        maxCap = size;
        heap = new int[size];
        nbOfElem = 0;
    }

    public int parent(int i){ 
        return (i-1)/2; 
    } 

    public void push(int val){
        if (nbOfElem == maxCap) { 
            System.out.println("Plus de place !");
            return; 
        } 
    
        // First insert the new key at the end 
        nbOfElem++; 
        int i = nbOfElem - 1; 
        heap[i] = val; 
    
        // Fix the min heap property if it is violated 
        while (i != 0 && heap[parent(i)] > heap[i]) 
        { 
            int temp = heap[i]; 
            heap[i] = heap[parent(i)]; 
            heap[parent(i)] = temp; 
            i = parent(i); 
        } 
    }

    public void populate(int nbValues){
        Random random = new Random();
        for (int i = 0; i < nbValues; i++) {
            int randomVal = random.nextInt(100);
             //System.out.println(randomVal);
            this.push(randomVal);
        }
        //return heap;
    }

    /*private static void Tamiser(int[] arbre, int noeud, int n){
        int k = noeud;
        int j = 2 * k;

        while (j <= n)
        {
            if ((j < n) && (arbre[j] < arbre[j + 1]))
                j++;

            if (arbre[k] < arbre[j])
            {
                int swap = arbre[k];
                arbre[k] = arbre[j];
                arbre[j] = swap;
                k = j;
                j = 2 * k;
            }
            else
                break;
        }
    }

    public void heapSort(){
        for (int i = this.heap.length >> 1; i >= 0; i--)
            Tamiser(this.heap, i, this.heap.length - 1);

        for (int i = this.heap.length - 1; i >= 1; i--)
        {
            int swap = this.heap[i];
            this.heap[i] = this.heap[0];
            this.heap[0] = swap;
            Tamiser(this.heap, 0, i - 1);
        }
    }*/

    public void printHeap(){
        for (int x : this.heap) {
            System.out.println(x);
        }
    }

    public static void main(String[] args){
        BinaryHeap test = new BinaryHeap(10);
        test.populate(19);

        test.printHeap();
    }

}